'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="EmployeesFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:00 2005</creation-datetime>
'		<description>
'			Contains VB.NET code EmployeesFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

 Namespace NCacheSample

	Public Interface IEmployeesFactory
        Function Load(ByRef objInfo As Employees, ByVal nDepth As Int32, ByVal bCacheEnalbed As Boolean)
        Function Insert(ByRef objInfo As Employees, ByVal nDepth As Int32)
        Function Update(ByRef objInfo As Employees, ByVal nDepth As Int32)
        Function Delete(ByRef objInfo As Employees, ByVal nDepth As Int32)
        Function Save(ByRef objList As EmployeesCollection, ByVal nDepth As Int32)
        Function DeleteColl(ByRef objList As EmployeesCollection, ByVal nDepth As Int32)
        'Function ProcessDataSet(ByVal dataSet As DataSet)

        Function getAll(ByVal bCacheEnabled As Boolean) As EmployeesCollection
End Interface
	
	''' <summary>
	''' Object <c>Employees</c>Factory. Provides implementation.
	''' </summary>
	''' <remarks>
	'''		
	''' </remarks>
	<  ClassInterface(ClassInterfaceType.AutoDual)> _
	    Public Class EmployeesFactory
        Inherits DbObject
        Implements IEmployeesFactory
		' define constants here for either dynamic SQL or stored procedure calls
		
		Private Shared _stQryObject As String 
		Private Shared _stPKQryObject As String 
		
		Private Const USE_STORE_PROC As Boolean = False
		Private Const STD_LOAD_SQL As String = _
						"SELECT" & _ 
						"     a13.[EmployeeID] as EmployeeID, a13.[LastName] as LastName," & _ 
						"     a13.[FirstName] as FirstName, a13.[Title] as Title," & _ 
						"     a13.[TitleOfCourtesy] as TitleOfCourtesy, a13.[BirthDate] as BirthDate," & _ 
						"     a13.[HireDate] as HireDate, a13.[Address] as Address," & _ 
						"     a13.[City] as City, a13.[Region] as Attrib_Region," & _ 
						"     a13.[PostalCode] as PostalCode, a13.[Country] as Country," & _ 
						"     a13.[HomePhone] as HomePhone, a13.[Extension] as Extension," & _ 
						"     a13.[Photo] as Photo, a13.[Notes] as Notes," & _ 
						"     a13.[ReportsTo] as ReportsTo" & _ 
						" FROM" & _ 
						"     [Employees] a13" & _ 
						" WHERE" & _ 
						"     [EmployeeID] = ?" 
		Private Const STD_INSERT_SQL As String = _
						"INSERT INTO [Employees]" & _ 
						"    ([LastName], [FirstName]" & _ 
						"     , [Title], [TitleOfCourtesy]" & _ 
						"     , [BirthDate], [HireDate]" & _ 
						"     , [Address], [City]" & _ 
						"     , [Region], [PostalCode]" & _ 
						"     , [Country], [HomePhone]" & _ 
						"     , [Extension], [Photo]" & _ 
						"     , [Notes], [ReportsTo]" & _ 
						"     ) VALUES (?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     )" 
		Private Const STD_DELETE_SQL As String = _
						"DELETE FROM [Employees] WHERE [EmployeeID] = ?" 
		Private Const STD_UPDATE_SQL As String = _
						"UPDATE" & _ 
						"     [Employees]" & _ 
						" SET" & _ 
						"     [LastName] = ?, [FirstName] = ?," & _ 
						"     [Title] = ?, [TitleOfCourtesy] = ?," & _ 
						"     [BirthDate] = ?, [HireDate] = ?," & _ 
						"     [Address] = ?, [City] = ?," & _ 
						"     [Region] = ?, [PostalCode] = ?," & _ 
						"     [Country] = ?, [HomePhone] = ?," & _ 
						"     [Extension] = ?, [Photo] = ?," & _ 
						"     [Notes] = ?, [ReportsTo] = ?" & _ 
						" WHERE" & _ 
						"     [EmployeeID] = ?" 
		Private Const getAll_SQL As String = _
						"SELECT" & _ 
						"     a13.[EmployeeID] as EmployeeID, a13.[LastName] as LastName," & _ 
						"     a13.[FirstName] as FirstName, a13.[ReportsTo] as ReportsTo," & _ 
						"     a13.[Notes] as Notes, a13.[Photo] as Photo," & _ 
						"     a13.[Extension] as Extension, a13.[HomePhone] as HomePhone," & _ 
						"     a13.[Country] as Country, a13.[PostalCode] as PostalCode," & _ 
						"     a13.[Region] as Attrib_Region, a13.[City] as City," & _ 
						"     a13.[Address] as Address, a13.[HireDate] as HireDate," & _ 
						"     a13.[BirthDate] as BirthDate, a13.[TitleOfCourtesy] as TitleOfCourtesy," & _ 
						"     a13.[Title] as Title" & _ 
						" FROM" & _ 
						"     [Employees] a13" 
		

		
        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("Employees")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub		
		
        	

	Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub	

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub
        
        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub

		#Region "[Cache Keys]"
        Private Function GetPKQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...
            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If
            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...
            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If
            GetQueryKey = key
        End Function
					
		Private Sub InvalidateAll()
            NCacheUtil.Remove(GetQueryKey()) '
            NCacheUtil.Remove(GetPKQueryKey()) '
            _stQryObject = Nothing
        End Sub
		Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type And NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then
                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then
                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then
			
            End If
        End Sub
		
		#End Region


		#Region  " Standard Methods "


		' <summary>
		' 	Load (Standard Load Method [Cache Enabled])
		' </summary>
		' <remarks>
		' 	Loads a record from the <c>[Employees]</c> table given by
		' 	the specified primary key.
		' </remarks>
		' <param name="objInfo">The <c>Employees</c> info object containing the primary key.</param>
		' <param name="nDepth">Specifies depth of children should be loaded.</param>
		Public Function Load(ByRef objInfo As Employees, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
		Implements IEmployeesFactory.Load

            Dim objKey As String
            Dim obj As Object
			objKey = "Employees." & objInfo.EmployeeID 
            Try
				If bCacheEnable Then
					obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
					If obj Is Nothing Then ' Cache miss..
						_Load(objInfo, nDepth, bCacheEnable)
                        Stats.ReadTripsToDB = 1
                        Stats.ObjsReadFromDB = 1
						NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
						Exit Function
					End If
					Stats.ObjsReadFromCache= 1

                    Dim objTemp As Employees = CType(obj, Employees)
                    objInfo.Copy(objTemp) ' Cache hit..

					If nDepth <> 0 Then
						LoadChildren(objInfo, nDepth - 1, bCacheEnable)
					End If
				Else 
					_Load(objInfo,nDepth, bCacheEnable)
                    Stats.ObjsReadFromDB = 1
                    Stats.ReadTripsToDB = 1
                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                    End If
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
				End If
			Catch e As Exception
                Throw e
            End Try
        End Function

		' <summary>
		' 	Load (Standard Load Method)
		' </summary>
		' <remarks>
		' 	Loads a record from the <c>[Employees]</c> table given by
		' 	the specified primary key.
		' </remarks>
		' <param name="objInfo">The <c>Employees</c> info object containing the primary key.</param>
		' <param name="nDepth">Specifies depth of children should be loaded.</param>
        
		
			Private Function _Load(ByRef objInfo As Employees, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
		
			Try
				Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)
			
				AddCmdParameter("@EmployeeID", TDevFramework.EDataType.eInt, objInfo.EmployeeID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("EmployeeID"))
				ExecuteReader()
				while (Read())
					FillPersistentObject(objInfo)
					objInfo.IsNew = False
					objInfo.Dirty = False
					bRecordsFound = True
				End While	
				ReleaseReader()
				If Not bRecordsFound Then 
					Throw new RecordNotFoundException("No record found against given search criteria.")
				End If
				
				If (nDepth <> 0) Then
					LoadChildren(objInfo, nDepth - 1,bCacheEnable)
				End If
				
				SetStatus(EStatus.eSuccess)
				ReleaseCommand()
			
			Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
			Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
			End Try
		End Function


		' <summary>
		' 	Insert (Standard Insert Method)
		' </summary>
		' <remarks>
		' 	Adds a new record into the <c>[Employees]</c> table.
		' </remarks>
		' <param name="objInfo">The <c>Employees</c> info object to be inserted.</param>
		' <param name="nDepth">Specifies depth of children should be inserted.</param>
        
		Public Function Insert(ByRef objInfo As Employees, ByVal nDepth As Int32) _
			Implements IEmployeesFactory.Insert
			Try
				
                objInfo.ValidateRequiredFields()
	
                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
				If ( nDepth <> 0) Then
				End If
				'Read the persistent object
				ReadPersistentObject(objInfo)
				ExecuteNonQuery()

				Prepare("SELECT @@IDENTITY AS EmployeeID;", false)
				ExecuteReader()

				If (Read ()) Then
						If (Not IsNull("EmployeeID")) Then
							objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
						End If
				End If
				ReleaseReader()
			
				
				If ( nDepth <> 0) Then
				End If				
	
				

				SetStatus(EStatus.eSuccess)
				ReleaseCommand()
				Stats.WriteTripsToDB = 1
                objInfo.IsNew = False
                objInfo.Dirty = False

                Dim objKey As String
                objKey = "Employees." & objInfo.EmployeeID.ToString()

				NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
				Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK AND NCacheUtil.InvalidateType.QueryCollection,Nothing)
				
			Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
			End Try
		End Function

		' <summary>
		' 	Delete (Standard Delete Method)
		' </summary>
		' <remarks>
		' 	Deletes the record in <c>[Employees]</c> table given
		'   by its primary key.
		' </remarks>
		' <param name="objInfo">The <c>Employees</c> info object used to delete the record.</param>
		' <param name="nDepth">Specifies depth of children should be deleted.</param>
        
		Public Function Delete(ByRef objInfo As Employees, ByVal nDepth As Int32) _
			Implements IEmployeesFactory.Delete
			Try
			
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)	
			
				If (nDepth <> 0) Then
				End If
				AddCmdParameter("@EmployeeID", TDevFramework.EDataType.eInt, objInfo.EmployeeID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("EmployeeID"))
				ExecuteNonQuery()
				Stats.WriteTripsToDB = 1

				
				SetStatus(EStatus.eSuccess)
				ReleaseCommand()

                Dim objKey As String
                objKey = "Employees." & objInfo.EmployeeID.ToString()

				NCacheUtil.Remove(objKey) ' Invalidating all PK query Collections and the Related Collection...
				Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Remove all the NonPK/Partial collections
				
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


		' <summary>
		' 	Update (Standard Update Method)
		' </summary>
		' <remarks>
		' 	Updates the record in <c>[Employees]</c> table given
		' by its primary key.
		' </remarks>
		' <param name="objInfo">The <c>Employees</c> info object used to update the record.</param>
		' <param name="nDepth">Specifies depth of children should be updated.</param>
        
		Public Function Update(ByRef objInfo As Employees, ByVal nDepth As Int32) _
			Implements IEmployeesFactory.Update
			Try
				
                CheckPrimaryKeyValues(objInfo)
               
				objInfo.ValidateRequiredFields()
			Prepare(STD_UPDATE_SQL, USE_STORE_PROC)
				If (nDepth <> 0) Then
				End If
				ReadPersistentObject(objInfo)
				AddCmdParameter("@EmployeeID", TDevFramework.EDataType.eInt, objInfo.EmployeeID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("EmployeeID"))

				ExecuteNonQuery()
                Stats.WriteTripsToDB = 1
                objInfo.Dirty = False

                Dim objKey As String
                objKey = "Employees." & objInfo.EmployeeID.ToString()

				NCacheUtil.Remove(objKey)  ' Invalidating RElated Collection PKQueryCollection...
				Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
				' adding the copy of this object in Cache.. 
				NCacheUtil.Store(objKey,objInfo, Nothing, DateTime.Now.AddMinutes(30))
			
				
				If (nDepth <> 0) Then
				End If
				SetStatus(EStatus.eSuccess)
				ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function
		
		#End Region
		
		
		Public Function Save(ByRef objList As EmployeesCollection, ByVal nDepth As Int32) _
            Implements IEmployeesFactory.Save
		
	    Dim objInfo As Employees = Nothing
            Dim count As Integer
            
            For count = 0 To  objList.Count - 1
                objInfo = objList(count)
                
                If (objInfo.IsNew) Then
                    Me.Insert(objInfo, nDepth)
                ElseIf (objInfo.Dirty) Then
                    Me.Update(objInfo, nDepth)
                
                End If
                
                
            Next count
			
            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Employees)
                Me.Delete(objInfo, nDepth)
            Next count
		End Function

		
		' <summary>
		' 	DeleteColl (Standard Collection Delete Method)
		' </summary>
		' <remarks>
		' 	Performs standard delete on a collection of <c>Employees</c> objects.
		' </remarks>
		' <param name="objList">The <c>EmployeesCollection</c> object.</param>
		' <param name="nDepth">integer that is passed to each delete operation.</param>		
		
		Public Function DeleteColl(ByRef objList As EmployeesCollection, ByVal nDepth As Int32) _
            Implements IEmployeesFactory.DeleteColl
			
            Dim objInfo As Employees = Nothing
            Dim count As Integer
            
            For count = 0 To  objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth)
                End If
            Next count
            
            For count = 0 To  objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Employees)
                Me.Delete(objInfo, nDepth)
            Next count  
            
	End Function
			
		

	#Region " Queries "

		' <summary>
		' 	getAll (Query Method)
		' </summary>
		' <remarks>
		' 	
		' </remarks>
		' <returns><c>EmployeesCollection</c> object containing all the records 
		'	returned in the resultset.</returns>
		
		Public Function getAll(ByVal bCacheEnable As Boolean) As EmployeesCollection _
			Implements IEmployeesFactory.getAll
						
			  Dim objKey As String 
			  Dim cacheKeys As ArrayList = new ArrayList 
			  Dim obj As Object
			  
				  objKey = "Employees.getAll"
			  If bCacheEnable Then
				  obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, EmployeesCollection).Count
                    Return CType(obj, EmployeesCollection) ' Return from Cache..
                End If
            End If
			  
			Dim objInfo As Employees
			Dim objList As EmployeesCollection = New EmployeesCollection

			Try 
				
				Prepare(getAll_SQL, USE_STORE_PROC)
			
                ExecuteReader()
                While (Read())
                    objInfo = New Employees
                    If (Not IsNull("EmployeeID")) Then
                        objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
                    End If
                    If (Not IsNull("LastName")) Then
                        objInfo.LastName = Convert.ToString(getValue("LastName"))
                    End If
                    If (Not IsNull("FirstName")) Then
                        objInfo.FirstName = Convert.ToString(getValue("FirstName"))
                    End If
                    If (Not IsNull("ReportsTo")) Then
                        objInfo.ReportsTo = Convert.ToInt32(getValue("ReportsTo"))
                    End If
                    If (Not IsNull("Notes")) Then
                        objInfo.Notes = Convert.ToString(getValue("Notes"))
                    End If
                    If (Not IsNull("Photo")) Then
                        objInfo.Photo = getBytes("Photo")
                    End If
                    If (Not IsNull("Extension")) Then
                        objInfo.Extension = Convert.ToString(getValue("Extension"))
                    End If
                    If (Not IsNull("HomePhone")) Then
                        objInfo.HomePhone = Convert.ToString(getValue("HomePhone"))
                    End If
                    If (Not IsNull("Country")) Then
                        objInfo.Country = Convert.ToString(getValue("Country"))
                    End If
                    If (Not IsNull("PostalCode")) Then
                        objInfo.PostalCode = Convert.ToString(getValue("PostalCode"))
                    End If
                    If (Not IsNull("Attrib_Region")) Then
                        objInfo.Attrib_Region = Convert.ToString(getValue("Attrib_Region"))
                    End If
                    If (Not IsNull("City")) Then
                        objInfo.City = Convert.ToString(getValue("City"))
                    End If
                    If (Not IsNull("Address")) Then
                        objInfo.Address = Convert.ToString(getValue("Address"))
                    End If
                    If (Not IsNull("HireDate")) Then
                        objInfo.HireDate = Convert.ToDateTime(getValue("HireDate"))
                    End If
                    If (Not IsNull("BirthDate")) Then
                        objInfo.BirthDate = Convert.ToDateTime(getValue("BirthDate"))
                    End If
                    If (Not IsNull("TitleOfCourtesy")) Then
                        objInfo.TitleOfCourtesy = Convert.ToString(getValue("TitleOfCourtesy"))
                    End If
                    If (Not IsNull("Title")) Then
                        objInfo.Title = Convert.ToString(getValue("Title"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    Stats.ObjsReadFromDB = 1
                    objList.Add(objInfo)

                    If bCacheEnable Then

                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                        Dim key As String
                        key = "Employees." & objInfo.EmployeeID
                        cacheKeys.Add(key)
                        NCacheUtil.Store(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If

                    
                End While


                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1
                If bCacheEnable Then
                    If cacheKeys.Count > 0 Then

                        cacheKeys.Add(GetPKQueryKey())
                        NCacheUtil.Store(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                    End If
                End If
                
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function
		
		
		
		
		
		#End Region

		#Region " Bulk Update Operations "

		#End Region

		#Region " Bulk Delete Operations "

		#End Region

		#Region " Custom Insert Operations "

		#End Region

		#Region " Custom Update Operations "

		#End Region

		#Region " Custom Load Operations "

		#End Region

		#Region " Stored Procedures "
	
		#End Region

		#Region " Utility Methods "

		Private Function FillPersistentObject(ByVal objInfo As Employees)
		
			If (Not IsNull("EmployeeID")) Then
				objInfo.EmployeeID = Convert.ToInt32(getValue("EmployeeID"))
			End If
			If (Not IsNull("LastName")) Then
				objInfo.LastName = Convert.ToString(getValue("LastName"))
			End If
			If (Not IsNull("FirstName")) Then
				objInfo.FirstName = Convert.ToString(getValue("FirstName"))
			End If
			If (Not IsNull("Title")) Then
				objInfo.Title = Convert.ToString(getValue("Title"))
			End If
			If (Not IsNull("TitleOfCourtesy")) Then
				objInfo.TitleOfCourtesy = Convert.ToString(getValue("TitleOfCourtesy"))
			End If
			If (Not IsNull("BirthDate")) Then
				objInfo.BirthDate = Convert.ToDateTime(getValue("BirthDate"))
			End If
			If (Not IsNull("HireDate")) Then
				objInfo.HireDate = Convert.ToDateTime(getValue("HireDate"))
			End If
			If (Not IsNull("Address")) Then
				objInfo.Address = Convert.ToString(getValue("Address"))
			End If
			If (Not IsNull("City")) Then
				objInfo.City = Convert.ToString(getValue("City"))
			End If
			If (Not IsNull("Attrib_Region")) Then
				objInfo.Attrib_Region = Convert.ToString(getValue("Attrib_Region"))
			End If
			If (Not IsNull("PostalCode")) Then
				objInfo.PostalCode = Convert.ToString(getValue("PostalCode"))
			End If
			If (Not IsNull("Country")) Then
				objInfo.Country = Convert.ToString(getValue("Country"))
			End If
			If (Not IsNull("HomePhone")) Then
				objInfo.HomePhone = Convert.ToString(getValue("HomePhone"))
			End If
			If (Not IsNull("Extension")) Then
				objInfo.Extension = Convert.ToString(getValue("Extension"))
			End If
			If (Not IsNull("Photo")) Then
				objInfo.Photo = getBytes("Photo")
			End If
			If (Not IsNull("Notes")) Then
				objInfo.Notes = Convert.ToString(getValue("Notes"))
			End If
			If (Not IsNull("ReportsTo")) Then
				objInfo.ReportsTo = Convert.ToInt32(getValue("ReportsTo"))
			End If
		
		End Function

		Private Function ReadPersistentObject(objInfo As Employees)
		
			AddCmdParameter("@LastName", TDevFramework.EDataType.eVarchar, objInfo.LastName, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("LastName"))
			AddCmdParameter("@FirstName", TDevFramework.EDataType.eVarchar, objInfo.FirstName, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("FirstName"))
			AddCmdParameter("@Title", TDevFramework.EDataType.eVarchar, objInfo.Title, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Title"))
			AddCmdParameter("@TitleOfCourtesy", TDevFramework.EDataType.eVarchar, objInfo.TitleOfCourtesy, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("TitleOfCourtesy"))
			AddCmdParameter("@BirthDate", TDevFramework.EDataType.eDateTime, objInfo.BirthDate, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("BirthDate"))
			AddCmdParameter("@HireDate", TDevFramework.EDataType.eDateTime, objInfo.HireDate, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("HireDate"))
			AddCmdParameter("@Address", TDevFramework.EDataType.eVarchar, objInfo.Address, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Address"))
			AddCmdParameter("@City", TDevFramework.EDataType.eVarchar, objInfo.City, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("City"))
			AddCmdParameter("@Attrib_Region", TDevFramework.EDataType.eVarchar, objInfo.Attrib_Region, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Attrib_Region"))
			AddCmdParameter("@PostalCode", TDevFramework.EDataType.eVarchar, objInfo.PostalCode, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("PostalCode"))
			AddCmdParameter("@Country", TDevFramework.EDataType.eVarchar, objInfo.Country, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Country"))
			AddCmdParameter("@HomePhone", TDevFramework.EDataType.eVarchar, objInfo.HomePhone, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("HomePhone"))
			AddCmdParameter("@Extension", TDevFramework.EDataType.eVarchar, objInfo.Extension, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Extension"))
			AddCmdParameter("@Photo", TDevFramework.EDataType.eVarBinary, objInfo.Photo, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Photo"))
			AddCmdParameter("@Notes", TDevFramework.EDataType.eVarchar, objInfo.Notes, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Notes"))
			AddCmdParameter("@ReportsTo", TDevFramework.EDataType.eInt, objInfo.ReportsTo, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("ReportsTo"))
		
		End Function
		
		
        	Private Function CheckPrimaryKeyValues(ByVal objInfo As Employees) As Boolean
		If ((objInfo("EmployeeID").Null)) Then
				Throw New Exception("Primary key must have some valid value.")
			End If
            Return True
            
        End Function
        
		#End Region
		
		#Region "LoadChildren Methods"

		Public Function LoadChildren(ByVal objInfo As Employees, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) 
		End Function
		
		#End Region
        
    End Class
End Namespace
