'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


Imports NCacheSample
Imports System.Configuration
#Region "Class CustomerForm"
Public Class CustomerForm
    Inherits System.Windows.Forms.Form

#Region "Private members"
    Private _document As Document
    Private _orderForm As OrderForm
    Private _monitorStats As MonitorStatistics
    Private _isOutProc As Boolean
    Private _loaded As Boolean
#End Region

#Region "Properties"
    'Gets whether cache is enabled or not
    Public ReadOnly Property CacheEnabled() As Boolean
        Get
            Return _document.CacheEnabled
        End Get
    End Property
#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        _document = New Document
        'Dim cacheID = ConfigurationSettings.AppSettings.Get("NCache.CacheId")
        'If cacheID Is Nothing Then
        '    cacheID = "myCache"
        'End If
        '_document.UseCache = cacheID
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents _rbtnDisableNCache As System.Windows.Forms.RadioButton
    Friend WithEvents _rbtnEnableNCache As System.Windows.Forms.RadioButton
    Friend WithEvents _cmbCustomer As System.Windows.Forms.ComboBox
    Friend WithEvents _btnTakeOrder As System.Windows.Forms.Button
    Friend WithEvents _btnDone As System.Windows.Forms.Button
    Friend WithEvents _lblStatus As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(CustomerForm))
        Me._cmbCustomer = New System.Windows.Forms.ComboBox
        Me.Label1 = New System.Windows.Forms.Label
        Me._rbtnDisableNCache = New System.Windows.Forms.RadioButton
        Me._rbtnEnableNCache = New System.Windows.Forms.RadioButton
        Me._btnTakeOrder = New System.Windows.Forms.Button
        Me._btnDone = New System.Windows.Forms.Button
        Me._lblStatus = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        '_cmbCustomer
        '
        Me._cmbCustomer.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me._cmbCustomer.Location = New System.Drawing.Point(72, 16)
        Me._cmbCustomer.Name = "_cmbCustomer"
        Me._cmbCustomer.Size = New System.Drawing.Size(112, 21)
        Me._cmbCustomer.TabIndex = 0
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 18)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(64, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Customer:"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.TopRight
        '
        '_rbtnDisableNCache
        '
        Me._rbtnDisableNCache.Location = New System.Drawing.Point(24, 69)
        Me._rbtnDisableNCache.Name = "_rbtnDisableNCache"
        Me._rbtnDisableNCache.TabIndex = 38
        Me._rbtnDisableNCache.Text = "Disble NCache"
        '
        '_rbtnEnableNCache
        '
        Me._rbtnEnableNCache.Checked = True
        Me._rbtnEnableNCache.Location = New System.Drawing.Point(24, 48)
        Me._rbtnEnableNCache.Name = "_rbtnEnableNCache"
        Me._rbtnEnableNCache.TabIndex = 37
        Me._rbtnEnableNCache.TabStop = True
        Me._rbtnEnableNCache.Text = "Enable NCache"
        '
        '_btnTakeOrder
        '
        Me._btnTakeOrder.BackColor = System.Drawing.SystemColors.ActiveBorder
        Me._btnTakeOrder.Location = New System.Drawing.Point(80, 104)
        Me._btnTakeOrder.Name = "_btnTakeOrder"
        Me._btnTakeOrder.Size = New System.Drawing.Size(79, 24)
        Me._btnTakeOrder.TabIndex = 39
        Me._btnTakeOrder.Text = "&Take Order"
        '
        '_btnDone
        '
        Me._btnDone.BackColor = System.Drawing.SystemColors.ActiveBorder
        Me._btnDone.Location = New System.Drawing.Point(168, 104)
        Me._btnDone.Name = "_btnDone"
        Me._btnDone.Size = New System.Drawing.Size(79, 24)
        Me._btnDone.TabIndex = 40
        Me._btnDone.Text = "&Done"
        '
        '_lblStatus
        '
        Me._lblStatus.Location = New System.Drawing.Point(24, 136)
        Me._lblStatus.Name = "_lblStatus"
        Me._lblStatus.Size = New System.Drawing.Size(232, 16)
        Me._lblStatus.TabIndex = 41
        '
        'CustomerForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ClientSize = New System.Drawing.Size(274, 167)
        Me.Controls.Add(Me._lblStatus)
        Me.Controls.Add(Me._btnDone)
        Me.Controls.Add(Me._btnTakeOrder)
        Me.Controls.Add(Me._rbtnDisableNCache)
        Me.Controls.Add(Me._rbtnEnableNCache)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me._cmbCustomer)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "CustomerForm"
        Me.Text = "Customer Form"
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Event Handlers"
    'Loads the informatio of all the customers
    Private Sub OnCustomerFormActivated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        If Not _loaded Then
            GetCacheID()
            LoadAllCustomers()
            _loaded = True
        End If
    End Sub
    'Show the order form the customer
    Private Sub OnTakeOrder(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _btnTakeOrder.Click
        Dim customer As CustomerInfo
        If _cmbCustomer.Items.Count > 0 Then
            customer = CType(Me._cmbCustomer.SelectedItem, CustomerInfo)
            If _orderForm Is Nothing Then
                _orderForm = New OrderForm(Me, _document, customer.Id)
            ElseIf _orderForm.IsDisposed Then
                _orderForm = New OrderForm(Me, _document, customer.Id)
            End If
            'Stats.ResetStats()
            _orderForm.Show()
            _orderForm.Activate()
            If _document.IsInproc Then
                ShowStats()
            End If

        End If

    End Sub
    'Enables the cache
    Private Sub OnCacheEnable(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _rbtnEnableNCache.CheckedChanged
        If Not _document Is Nothing Then
            Try
                If CType(sender, RadioButton).Checked Then
                    Me._lblStatus.Text = "Initializing Cache"
                    
                    Me._lblStatus.Update()
                    Me.Cursor = Cursors.WaitCursor
                    _document.CacheEnabled = True
                    _document.ClearCache()
                    _document.LoadAllInCache()
                    Me._lblStatus.Text = ""
                    Stats.ResetStats()
                End If
            Catch ex As Exception
            Finally
                Me.Cursor = Cursors.Arrow
            End Try
        End If
    End Sub
    'Disables the cache
    Private Sub OnDisableCache(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _rbtnDisableNCache.CheckedChanged
        If Not _document Is Nothing Then
            _document.CacheEnabled = False
        End If
    End Sub
    'Closes the Customer form and order form if opened
    Private Sub OnDone(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _btnDone.Click
        Me.Close()
    End Sub
    'Closes the order form 
    Private Sub OnClose()
        If Not _orderForm Is Nothing Then
            If Not _orderForm.IsDisposed Then
                Me._orderForm.Close()
            End If
        End If
        If Not _monitorStats Is Nothing Then
            If Not _monitorStats.IsDisposed Then
                Me._monitorStats.Close()
            End If
        End If
        NCacheUtil.DisposeCache()
    End Sub
    'Closes the form
    Private Sub CustomerForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        OnClose()
    End Sub
#End Region

#Region "Utility Operatoina"
    'Gets the ID of the cache from configuraton file
    Private Sub GetCacheID()
        Try
            _document.UseCache = System.Configuration.ConfigurationSettings.AppSettings.Get("NCache.CacheId")
        Catch ex As Exception
            _document.UseCache = "myCache"
        End Try
    End Sub
    'Loads the information of three customers
    Public Sub LoadAllCustomers()
        _document.CacheEnabled = True
        _document.IsInproc = True
        _document.LoadAllInCache()
        AddToList(_document.GetCustomer("ANATR"))
        AddToList(_document.GetCustomer("ERNSH"))
        AddToList(_document.GetCustomer("BERGS"))
        Stats.ResetDBWithCacheStats()
        Stats.ResetStats()
        Me._cmbCustomer.SelectedIndex = 0
    End Sub
    'Populate combo box with customer names
    Public Sub AddToList(ByVal customer As Customers)
        Dim customerInfo As CustomerInfo
        Me._cmbCustomer.DisplayMember = "name"
        customerInfo = New CustomerInfo(customer.CustomerID, customer.ContactName)
        Me._cmbCustomer.Items.Add(customerInfo)
    End Sub
    'Show the stats window
    Public Sub ShowStats()
        If _monitorStats Is Nothing Then
            _monitorStats = New MonitorStatistics(Me)
        ElseIf _monitorStats.IsDisposed Then
            _monitorStats = New MonitorStatistics(Me)
        End If
        _monitorStats.Show()
        _monitorStats.Activate()
    End Sub
    'Close the statistics window'
    Public Sub CloseStats()
        If Not _monitorStats Is Nothing Then
            If Not _monitorStats.IsDisposed Then
                _monitorStats.Close()
            End If
        End If
    End Sub
#End Region

End Class
#End Region